【CodeForces-978F】解题报告(二分,排序,数据结构)

原始题目

Mentors

  • time limit per test3 seconds
  • memory limit per test256 megabytes
  • inputstandard input
  • outputstandard output

In BerSoft n programmers work, the programmer i is characterized by a skill ri.

A programmer a can be a mentor of a programmer b if and only if the skill of the programmer a is strictly greater than the skill of the programmer b (ra>rb) and programmers a and b are not in a quarrel.

You are given the skills of each programmers and a list of k pairs of the programmers, which are in a quarrel (pairs are unordered). For each programmer i, find the number of programmers, for which the programmer i can be a mentor.

Input

The first line contains two integers n and k (2≤n≤2⋅105, 0≤k≤min(2⋅105,n⋅(n−1)2)) — total number of programmers and number of pairs of programmers which are in a quarrel.

The second line contains a sequence of integers r1,r2,…,rn (1≤ri≤109), where ri equals to the skill of the i-th programmer.

Each of the following k lines contains two distinct integers x, y (1≤x,y≤n, x≠y) — pair of programmers in a quarrel. The pairs are unordered, it means that if x is in a quarrel with y then y is in a quarrel with x. Guaranteed, that for each pair (x,y) there are no other pairs (x,y) and (y,x) in the input.

Output

Print n integers, the i-th number should be equal to the number of programmers, for which the i-th programmer can be a mentor. Programmers are numbered in the same order that their skills are given in the input.

Examples

Input

4 2
10 4 10 15
1 2
4 3

Output

0 0 1 2 

Input

10 4
5 4 1 5 4 3 7 1 2 5
4 6
2 1
10 8
3 5

Output

5 4 0 5 3 3 9 0 2 5 

Note

In the first example, the first programmer can not be mentor of any other (because only the second programmer has a skill, lower than first programmer skill, but they are in a quarrel). The second programmer can not be mentor of any other programmer, because his skill is minimal among others. The third programmer can be a mentor of the second programmer. The fourth programmer can be a mentor of the first and of the second programmers. He can not be a mentor of the third programmer, because they are in a quarrel.

题目大意

给定n个人员skill值,并给出k个有矛盾的对,对于每个人,可以做skill值比自己小且没有矛盾人的导师。输出每一个人可做多少人的导师。

解题思路

  • 排序后对每个人的skill值二分查找,存储到ans[]中。
  • 对于每个矛盾对,skill值大的ans减1即可。

解题代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#define eps 1e-8
#define INF 0x3f3f3f3f
using namespace std;
typedef long long ll;
const int maxn=2e5+5;
ll a[maxn],b[maxn];
int ans[maxn],n,t,k;
int main()
{
while(~scanf("%d%d",&n,&k))
{
for(int i=0;i<n;i++)
{
scanf("%I64d",&a[i]);
b[i]=a[i];
}
sort(b,b+n);
for(int i=0;i<n;i++)
{
ans[i]=lower_bound(b,b+n,a[i])-b;
// printf("--%d--\n",ans[i]);
}

for(int i=0;i<k;i++)
{
int temp1,temp2;
scanf("%d%d",&temp1,&temp2);
if(a[temp1-1]>a[temp2-1]) ans[temp1-1]--;
else if(a[temp2-1]>a[temp1-1]) ans[temp2-1]--;
}
for(int i=0;i<n;i++)
{
if(i==0) printf("%d",ans[i]);
else printf(" %d",ans[i]);
}
printf("\n");
}
}

收获与反思

  • 二分查找 lower_bound的运用。
  • 注意quarrel列的在线计算。